package mapper;

import com.cycling74.max.MaxBox;

public class KeyMapControl extends MapControl {

	public KeyMapControl(MaxBox thebox, String name, int type, float min,
			float max) {
		super(thebox, name, type, min, max);
		this.type(MapControl.KEY);
	}

	public KeyMapControl(MaxBox thebox, String name, int type, float min,
			float max, float percision, float curve, boolean sendupoff, boolean sendvelocity, boolean banger) {
		super(thebox, name, type, min, max, percision, curve, sendupoff, sendvelocity, banger);
		this.type(MapControl.KEY);
	}
	
	public void send(int val) {
		if (val == 0) {
			if (_sendupoff) {
				if (_banger)
					_theBox.bang();
				else {
					_curval = _minval;
					_theBox.send(_curval);
				}
			}
		}
		else {
			if (_banger)
				_theBox.bang();
			else if (!_sendupoff && (_curval == _maxval)){
				_curval = _minval;
				_theBox.send(_curval);
			}
			else {
				_curval = _maxval;
				_theBox.send(_curval);
			}
		}
	}

}
